'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports.RemovedLocalObjects = exports.RemovedObjects = undefined;

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _bitId;

function _load_bitId() {
  return _bitId = require('../bit-id');
}

function _possibleConstructorReturn(self, call) { if (!self) { throw new ReferenceError("this hasn't been initialised - super() hasn't been called"); } return call && (typeof call === "object" || typeof call === "function") ? call : self; }

function _inherits(subClass, superClass) { if (typeof superClass !== "function" && superClass !== null) { throw new TypeError("Super expression must either be null or a function, not " + typeof superClass); } subClass.prototype = Object.create(superClass && superClass.prototype, { constructor: { value: subClass, enumerable: false, writable: true, configurable: true } }); if (superClass) Object.setPrototypeOf ? Object.setPrototypeOf(subClass, superClass) : subClass.__proto__ = superClass; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var RemovedObjects = exports.RemovedObjects = function () {
  function RemovedObjects(_ref) {
    var _ref$removedComponent = _ref.removedComponentIds,
        removedComponentIds = _ref$removedComponent === undefined ? new (_bitId || _load_bitId()).BitIds() : _ref$removedComponent,
        _ref$missingComponent = _ref.missingComponents,
        missingComponents = _ref$missingComponent === undefined ? new (_bitId || _load_bitId()).BitIds() : _ref$missingComponent,
        _ref$removedDependenc = _ref.removedDependencies,
        removedDependencies = _ref$removedDependenc === undefined ? new (_bitId || _load_bitId()).BitIds() : _ref$removedDependenc,
        _ref$dependentBits = _ref.dependentBits,
        dependentBits = _ref$dependentBits === undefined ? {} : _ref$dependentBits;

    _classCallCheck(this, RemovedObjects);

    this.removedComponentIds = [];
    this.missingComponents = [];
    this.dependentBits = {};
    this.removedDependencies = [];

    this.removedComponentIds = removedComponentIds;
    this.missingComponents = missingComponents;
    this.dependentBits = dependentBits;
    this.removedDependencies = removedDependencies;
  }

  _createClass(RemovedObjects, null, [{
    key: 'fromObjects',
    value: function fromObjects(payload) {
      var missingComponents = payload.missingComponents.map(function (id) {
        return new (_bitId || _load_bitId()).BitId(id);
      });
      var removedComponentIds = payload.removedComponentIds.map(function (id) {
        return new (_bitId || _load_bitId()).BitId(id);
      });
      var removedDependencies = payload.removedDependencies.map(function (id) {
        return new (_bitId || _load_bitId()).BitId(id);
      });
      return new RemovedObjects({
        missingComponents,
        removedComponentIds,
        removedDependencies,
        dependentBits: payload.dependentBits
      });
    }
  }]);

  return RemovedObjects;
}();

var RemovedLocalObjects = exports.RemovedLocalObjects = function (_RemovedObjects) {
  _inherits(RemovedLocalObjects, _RemovedObjects);

  function RemovedLocalObjects() {
    var removedComponentIds = arguments.length > 0 && arguments[0] !== undefined ? arguments[0] : [];
    var missingComponents = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : [];
    var modifiedComponents = arguments.length > 2 && arguments[2] !== undefined ? arguments[2] : [];
    var dependentBits = arguments.length > 3 && arguments[3] !== undefined ? arguments[3] : {};
    var removedDependencies = arguments.length > 4 && arguments[4] !== undefined ? arguments[4] : [];

    _classCallCheck(this, RemovedLocalObjects);

    var _this = _possibleConstructorReturn(this, (RemovedLocalObjects.__proto__ || Object.getPrototypeOf(RemovedLocalObjects)).call(this, { removedComponentIds, missingComponents, removedDependencies, dependentBits }));

    _this.modifiedComponents = modifiedComponents;
    return _this;
  }

  return RemovedLocalObjects;
}(RemovedObjects);
//# sourceMappingURL=removed-components.js.map